// Aprenent allows to make computations on polytopes such as finding vertices, intersecting, Minkowski sums, ...
//     Copyright (C) 2013 : Delos Vincent
//
//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
//
//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/// \file Aprenent.java
/// \author Delos Vincent

import java.io.*;
import java.awt.*;
import java.net.URL;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;

import javax.imageio.*;
import javax.sound.sampled.*;
import javax.swing.*;



public class Aprenent extends JFrame
{
    Aprenent(String name) {
	super(name);
	_nbImatges = ImgSoundsLoader.getAnimalsSize();
	_imatges = ImgSoundsLoader.getAnimalsImatges();
	_sons = ImgSoundsLoader.getAnimalsSounds();
	_kindOfImg = "ptigre.png";
	if (_imatges == null)
	    System.err.println("Aprenent::Aprenent() Null pointer _imatges");
	_nbNens = ImgSoundsLoader.getNensSize();
	_nensImg = ImgSoundsLoader.getNensImatges();
	_nensSon = ImgSoundsLoader.getNensSounds();
    }


    public JMenuBar createMenuBar() {
        JMenuBar menuBar;
        JMenu menu, menuHelp;
        JMenuItem menuItemAnimal, menuItemFormes, menuItemColors, menuItemHelp;

        //Create the menu bar.
        menuBar = new JMenuBar();

        //Build the first menu.
        menu = new JMenu("Cambiar lo tema");
        menu.setMnemonic(KeyEvent.VK_C);
        menu.getAccessibleContext().setAccessibleDescription("<html> Que s'i p&ograve;t causir au miei de tres t&egrave;mas </html>");
        menuBar.add(menu);

        //a group of JMenuItems
	ImageIcon capos = makeIcon("./img/cap_os.png");
	if (capos != null)
	    menuItemAnimal = new JMenuItem("Animals", capos);
	else {
	    System.err.println("Resource not found: ./img/cap_os.png");
	    menuItemAnimal = new JMenuItem("Animals");
	}
	menuItemAnimal.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    _nbImatges = ImgSoundsLoader.getAnimalsSize();
		    _imatges = ImgSoundsLoader.getAnimalsImatges();
		    _sons = ImgSoundsLoader.getAnimalsSounds();
		    _kindOfImg = "ptigre.png";
		    ImageIcon imIcon = makeIcon("./img/cap_os.png");
		    if (imIcon != null)
			_allTabs.setIconAt(0, imIcon);
		    _tabbedPane1.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane2.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane1.drawNumbers();
		    _tabbedPane2.drawNumbers();
		    _tabbedPane1.paintImatges();
		    _tabbedPane2.paintImatges();
		}
	    });
	menu.add(menuItemAnimal);

	ImageIcon menuFormes = makeIcon("./img/formes.png");
	if (menuFormes != null)
	    menuItemFormes = new JMenuItem("Formes", menuFormes);
	else {
	    System.err.println("Resource not found: ./img/formes.png");
	    menuItemFormes = new JMenuItem("Formes");
	}
	menuItemFormes.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    _nbImatges = ImgSoundsLoader.getFormesSize();
		    _imatges = ImgSoundsLoader.getFormesImatges();
		    _sons = ImgSoundsLoader.getFormesSounds();
		    _kindOfImg = "ptriangle.png";
		    ImageIcon imIcon = makeIcon("./img/formes.png");
		    if (imIcon != null)
			_allTabs.setIconAt(0, imIcon);
		    _tabbedPane1.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane2.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane1.drawNumbers();
		    _tabbedPane2.drawNumbers();
		    _tabbedPane1.paintImatges();
		    _tabbedPane2.paintImatges();
		}
	    });
	menu.add(menuItemFormes);

	ImageIcon menuColors = makeIcon("./img/colors.png");
	if (menuColors != null)
	    menuItemColors = new JMenuItem("Colors", menuColors);
	else {
	    System.err.println("Resource not found: ./img/colors.png");
	    menuItemColors = new JMenuItem("Colors");
	}
	menuItemColors.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    _nbImatges = ImgSoundsLoader.getColorsSize();
		    _imatges = ImgSoundsLoader.getColorsImatges();
		    _sons = ImgSoundsLoader.getColorsSounds();
		    _kindOfImg = "pquadrat.png";
		    ImageIcon imIcon = makeIcon("./img/colors.png");
		    if (imIcon != null)
			_allTabs.setIconAt(0, imIcon);
		    _tabbedPane1.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane2.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane1.drawNumbers();
		    _tabbedPane2.drawNumbers();
		    _tabbedPane1.paintImatges();
		    _tabbedPane2.paintImatges();
		}
	    });
	menu.add(menuItemColors);

	//Build the first menu.
	menuHelp = new JMenu("?");
	menuItemHelp = new JMenuItem("<html> Qu'ei aqu&ograve; ? </html>");
	menuItemHelp.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    JFrame frame = new JFrame("Aprenent");
		    frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		    String textToDisplay = "<html> Aprenem ! qu'ei un programa taus mainats desvolopat </html> \n";
		    textToDisplay += "<html> dab las condicions de la Lic&eacute;ncia Generau Publica de GNU. </html> \n\n";
		    textToDisplay += "<html> <i> Version 1.0.0 </i> </html> \n";
		    textToDisplay += "<html> <i> Votz : Cl&agrave;udia Laband&eacute;s (Per Noste www.pernoste.com) </i> </html> \n";
		    textToDisplay += "<html> <i> Programaire: Vicen&ccedil; Del&ograve;s </i> </html>";
		    JOptionPane.showMessageDialog(frame, textToDisplay, "Aprenem !", JOptionPane.INFORMATION_MESSAGE, new ImageIcon(getClass().getResource("./img/apre2.gif")));
		}
	    });
	menuHelp.add(menuItemHelp);
	menuBar.add(menuHelp);

	return menuBar;
    }

    ImageIcon makeIcon(String imgLocation) {
	ClassLoader classLoader = getClass().getClassLoader();
	URL imageURL = classLoader.getResource(imgLocation);
	ImageIcon imIcon=null;
	if (imageURL != null) {
	    imIcon = new ImageIcon(imageURL);
	}
	else {
	    System.err.println("Aprenent::makeIcon() Resource icon not found: " + imgLocation);
	}
	return imIcon;
    }

    public void addComponentsToPane(final Container pane) {
	JPanel mainPanel = new JPanel(false);
	_allTabs = new JTabbedPane();
	_tabbedPane1 = new TabbedPane1(_sons, _imatges, _nbImatges, _kindOfImg);
	_tabbedPane2 = new TabbedPane2(_sons, _imatges, _nbImatges, _kindOfImg);
	_tabbedPane3 = new TabbedPane3(_sons, _imatges, _nbImatges, _kindOfImg);
	_tabbedPane4 = new TabbedPane1(_nensSon, _nensImg, _nbNens, _kindOfImg);
	ImageIcon imIcon1 = makeIcon("./img/cap_os.png");
	ImageIcon imIcon2 = makeIcon("./img/tab_xifres.png");
	ImageIcon imIcon3 = makeIcon("./img/tab_mans.png");
	ImageIcon imIcon4 = makeIcon("./img/tab_nens.png");
	if (imIcon1 != null)
	    _allTabs.addTab( "", imIcon1, _tabbedPane1);
	else
	    _allTabs.addTab( "", _tabbedPane1);
	// Insert tab3 before tab2 !
	if (imIcon3 != null)
	    _allTabs.addTab( "", imIcon3, _tabbedPane3);
	else
	    _allTabs.addTab( "", _tabbedPane3);
	if (imIcon2 != null)
	    _allTabs.addTab( "", imIcon2, _tabbedPane2);
	else
	    _allTabs.addTab( "", _tabbedPane2);
	// Tab 4
	if (imIcon4 != null)
	    _allTabs.addTab( "", imIcon4, _tabbedPane4);
	else
	    _allTabs.addTab( "", _tabbedPane4);
	mainPanel.add(_allTabs);
	pane.add(mainPanel);
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event dispatch thread.
     */
    private static void createAndShowGUI() {
	//Create and set up the window.
	Aprenent frame = new Aprenent("Aprenem !");
	frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
	ImageIcon ico=null;
	ico = frame.makeIcon("./img/apre.gif");
	if (ico != null)
	    frame.setIconImage(ico.getImage());
	else
	    System.err.println("Aprenent::createAndShowGUI() Resource not found: " + "./img/apre.gif");
	//Set up the content pane.
	frame.setJMenuBar(frame.createMenuBar());
	frame.addComponentsToPane(frame.getContentPane());
	//Display the window.
	frame.pack();
	frame.setSize(new Dimension(1400, 700));
	frame.setVisible(true);
    }

    public static void main(String[] args) {
	/* Use an appropriate Look and Feel */
	try {
	    //UIManager.setLookAndFeel("com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
	    UIManager.setLookAndFeel("javax.swing.plaf.metal.MetalLookAndFeel");
	}
	catch (UnsupportedLookAndFeelException ex) {
	    ex.printStackTrace();
	}
	catch (IllegalAccessException ex) {
	    ex.printStackTrace();
	}
	catch (InstantiationException ex) {
	    ex.printStackTrace();
	}
	catch (ClassNotFoundException ex) {
	    ex.printStackTrace();
	}
	/* Turn off metal's use of bold fonts */
	UIManager.put("swing.boldMetal", Boolean.FALSE);
	//Schedule a job for the event dispatchi thread:
	//creating and showing this application's GUI.
	javax.swing.SwingUtilities.invokeLater(new Runnable() {
		public void run() {
		    createAndShowGUI();
		}
	    });
    }

    JTabbedPane _allTabs;
    TabbedPane1 _tabbedPane1;
    TabbedPane2 _tabbedPane2;
    TabbedPane3 _tabbedPane3;
    TabbedPane1 _tabbedPane4;

    String[] _sons;
    String[] _imatges;
    int _nbImatges;
    String _kindOfImg;
    int _nbNens;
    String[] _nensImg;
    String[] _nensSon;

} 
