// Aprenent allows to make computations on polytopes such as finding vertices, intersecting, Minkowski sums, ...
//     Copyright (C) 2013 : Delos Vincent
//
//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
//
//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/// \file Aprenent.java
/// \author Delos Vincent

import java.io.*;
import java.awt.*;
import java.net.URL;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;

import javax.imageio.*;
import javax.sound.sampled.*;
import javax.swing.*;



public class AprenentApplet extends JApplet
{

    public void init() throws NullPointerException {
	// Allow threads to execute.
	try {
	    System.setSecurityManager(null);
	}
	catch (Exception e) {
	    e.printStackTrace();
	}
	
	_nbImatges = ImgSoundsLoader.getAnimalsSize();
	_imatges = ImgSoundsLoader.getAnimalsImatges();
	_sons = ImgSoundsLoader.getAnimalsSounds();
	_kindOfImg = "ptigre.png";
	if (_imatges == null)
	    System.err.println("AprenentApplet::init() Null pointer _imatges");
	createAndShowGUI();
   }


    public JMenuBar createMenuBar() {
        JMenuBar menuBar;
        JMenu menu, menuHelp;
        JMenuItem menuItemAnimal, menuItemFormes, menuItemColors, menuItemHelp;

        //Create the menu bar.
        menuBar = new JMenuBar();

        //Build the first menu.
        menu = new JMenu("Canviar el tema");
        menu.setMnemonic(KeyEvent.VK_C);
        menu.getAccessibleContext().setAccessibleDescription("Pots triar entre 3 temes");
        menuBar.add(menu);

        //a group of JMenuItems
	ImageIcon capos = makeIcon("./cap_os.png");
	if (capos != null)
	    menuItemAnimal = new JMenuItem("Animals", capos);
	else {
	    System.err.println("Resource not found: ./cap_os.png");
	    menuItemAnimal = new JMenuItem("Animals");
	}
	menuItemAnimal.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    _nbImatges = ImgSoundsLoader.getAnimalsSize();
		    _imatges = ImgSoundsLoader.getAnimalsImatges();
		    _sons = ImgSoundsLoader.getAnimalsSounds();
		    _kindOfImg = "ptigre.png";
		    ImageIcon imIcon = makeIcon("./cap_os.png");
		    if (imIcon != null)
			_allTabs.setIconAt(0, imIcon);
		    _tabbedPane1.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane2.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane1.drawNumbers();
		    _tabbedPane2.drawNumbers();
		    _tabbedPane1.paintImatges();
		    _tabbedPane2.paintImatges();
		}
	    });
	menu.add(menuItemAnimal);

	ImageIcon menuFormes = makeIcon("./formes.png");
	if (menuFormes != null)
	    menuItemFormes = new JMenuItem("Formes", menuFormes);
	else {
	    System.err.println("Resource not found: ./formes.png");
	    menuItemFormes = new JMenuItem("Formes");
	}
	menuItemFormes.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    _nbImatges = ImgSoundsLoader.getFormesSize();
		    _imatges = ImgSoundsLoader.getFormesImatges();
		    _sons = ImgSoundsLoader.getFormesSounds();
		    _kindOfImg = "ptriangle.png";
		    ImageIcon imIcon = makeIcon("./formes.png");
		    if (imIcon != null)
			_allTabs.setIconAt(0, imIcon);
		    _tabbedPane1.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane2.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane1.drawNumbers();
		    _tabbedPane2.drawNumbers();
		    _tabbedPane1.paintImatges();
		    _tabbedPane2.paintImatges();
		}
	    });
	menu.add(menuItemFormes);

	ImageIcon menuColors = makeIcon("./colors.png");
	if (menuColors != null)
	    menuItemColors = new JMenuItem("Colors", menuColors);
	else {
	    System.err.println("Resource not found: ./colors.png");
	    menuItemColors = new JMenuItem("Colors");
	}
	menuItemColors.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    _nbImatges = ImgSoundsLoader.getColorsSize();
		    _imatges = ImgSoundsLoader.getColorsImatges();
		    _sons = ImgSoundsLoader.getColorsSounds();
		    _kindOfImg = "pquadrat.png";
		    ImageIcon imIcon = makeIcon("./colors.png");
		    if (imIcon != null)
			_allTabs.setIconAt(0, imIcon);
		    _tabbedPane1.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane2.setSoundsImg(_sons, _imatges, _nbImatges, _kindOfImg);
		    _tabbedPane1.drawNumbers();
		    _tabbedPane2.drawNumbers();
		    _tabbedPane1.paintImatges();
		    _tabbedPane2.paintImatges();
		}
	    });
	menu.add(menuItemColors);

	//Build the first menu.
	menuHelp = new JMenu("?");
	menuItemHelp = new JMenuItem("<html> Qu&egrave; &eacute;s? </html>");
	menuItemHelp.addActionListener(new ActionListener(){
		public void actionPerformed(ActionEvent e){
		    JFrame frame = new JFrame("Aprenent");
		    frame.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);
		    String textToDisplay = "<html> AprenentCAT &eacute;s un programa per la mainada desenvolupat </html> \n";
		    textToDisplay += "<html> sota les condicions de la Llic&egrave;ncia p&uacute;blica general de GNU. </html> \n\n";
		    textToDisplay += "<html> <i> Programador: Vincent Del&ograve;s </i> </html> \n";
		    textToDisplay += "<html> <i> Veu: Alba Fl&oacute;rez i Canals </i> </html>";
		    JOptionPane.showMessageDialog(frame, textToDisplay, "Aprenent", JOptionPane.INFORMATION_MESSAGE, new ImageIcon(getClass().getResource("./apre2.gif")));
		}
	    });
	menuHelp.add(menuItemHelp);
	menuBar.add(menuHelp);

	return menuBar;
    }

    ImageIcon makeIcon(String imgLocation) {
	ClassLoader classLoader = getClass().getClassLoader();
	URL imageURL = classLoader.getResource(imgLocation);
	ImageIcon imIcon=null;
	if (imageURL != null) {
	    imIcon = new ImageIcon(imageURL);
	}
	else {
	    System.err.println("Aprenent::makeIcon() Resource icon not found: " + imgLocation);
	}
	return imIcon;
    }

    public void addComponentsToPane(final Container pane) {
	JPanel mainPanel = new JPanel(false);
	_allTabs = new JTabbedPane();
	_tabbedPane1 = new TabbedPane1(_sons, _imatges, _nbImatges, _kindOfImg);
	_tabbedPane2 = new TabbedPane2(_sons, _imatges, _nbImatges, _kindOfImg);
	ImageIcon imIcon1 = makeIcon("./cap_os.png");
	ImageIcon imIcon2 = makeIcon("./tab_xifres.png");
	if (imIcon1 != null)
	    _allTabs.addTab( "", imIcon1, _tabbedPane1);
	else
	    _allTabs.addTab( "", _tabbedPane1);
	if (imIcon2 != null)
	    _allTabs.addTab( "", imIcon2, _tabbedPane2);
	else
	    _allTabs.addTab( "", _tabbedPane2);
	mainPanel.add(_allTabs);
	pane.add(mainPanel);
    }

    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event dispatch thread.
     */
    public void createAndShowGUI() {
	//Create and set up the window.
	//Set up the content pane.
	setJMenuBar(createMenuBar());
	addComponentsToPane(this.getContentPane());
	//Display the window.
	setSize(new Dimension(1400, 600));
	setVisible(true);
    }

    JTabbedPane _allTabs;
    TabbedPane1 _tabbedPane1;
    TabbedPane2 _tabbedPane2;

    String[] _sons;
    String[] _imatges;
    int _nbImatges;
    String _kindOfImg;

} 
