// Aprenent allows to make computations on polytopes such as finding vertices, intersecting, Minkowski sums, ...
//     Copyright (C) 2013 : Delos Vincent
//
//     This program is free software: you can redistribute it and/or modify
//     it under the terms of the GNU General Public License as published by
//     the Free Software Foundation, either version 3 of the License, or
//     (at your option) any later version.
//
//     This program is distributed in the hope that it will be useful,
//     but WITHOUT ANY WARRANTY; without even the implied warranty of
//     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//     GNU General Public License for more details.
//
//     You should have received a copy of the GNU General Public License
//     along with this program.  If not, see <http://www.gnu.org/licenses/>.
//
/// \file TabbedPane1.java
/// \author Delos Vincent

import java.io.*;
import java.awt.*;
import java.net.URL;
import java.awt.image.*;
import java.awt.event.*;
import java.util.*;

import javax.imageio.*;
import javax.sound.sampled.*;
import javax.swing.*;


public class TabbedPane2 extends JPanel
{
    TabbedPane2(String[] sons, String[] imatges, int nbImatges, String kindOfImg) {
	super(new BorderLayout(20,20));
	_sons = sons;
	_imatges = imatges;
	_nbImatges = nbImatges;
	_kindOfImg = kindOfImg;
	addComponentsToPanel();
    }

    public void setSoundsImg(String[] sons, String[] imatges, int nbImatges, String kindOfImg) {
	_sons = sons;
	_imatges = imatges;
	_nbImatges = nbImatges;
	_kindOfImg = kindOfImg;
    }

    protected void addComponentsToPanel() {
	// Set _sorteig & _number2find
	drawNumbers();
	createImatges();
    }

    public void createImatges() {
	_panel2 = new JPanel(new FlowLayout(FlowLayout.CENTER));

	_buttonImatge = new JButton();
	_buttonImatge.setHorizontalAlignment(SwingConstants.CENTER);
	paintImatges();

	JPanel panel2 = new JPanel(new GridLayout(5,4));
	_numberOfAllNumberButtons = 20;
	_allNumberButtons = new JButtonInt[_numberOfAllNumberButtons];
	for (int i=1; i<=_numberOfAllNumberButtons; ++i) {
	    String number = ""+i;
	    _allNumberButtons[i-1] = new JButtonInt(this, number, i);
	    _allNumberButtons[i-1].setFont(new Font(
						  _allNumberButtons[i-1].getFont().getFontName(),
						  _allNumberButtons[i-1].getFont().getStyle(),
						  3*_allNumberButtons[i-1].getFont().getSize()));
	    _allNumberButtons[i-1].addActionListener(new ActionListener() {
		public void actionPerformed(ActionEvent e){
		    JButtonInt jb = (JButtonInt) e.getSource();
		    if (jb.buttonNumber() == getNumber2find()) {
			sounds.playSounds("./son/moltbe.wav");
			drawNumbers();
			paintImatges();
		    }
		    else {
			String soundFile = "./son/" + jb.buttonNumber() + ".wav";
			sounds.playSounds(soundFile);
		    }
		}
	    });

	    panel2.add(_allNumberButtons[i-1]);
	}
	_panel2.add(panel2);

	add(_buttonImatge, BorderLayout.LINE_START);
	add(_panel2, BorderLayout.CENTER);
    }

    public void paintImatges() {
	String imgFile = "./img/" + _number2find + _kindOfImg;
	ImageIcon ico = makeIcon(imgFile);
	_buttonImatge.setIcon(ico);
    }

    /// Draw a number between 1 and 10.
    public void drawNumbers() {
	// Draw the random number to find.
	java.util.Random rand = new java.util.Random();
	int min = 20;
	int randnum = rand.nextInt(min)+1;
	// We want a fresh new number!
	while (randnum == _number2find)
	    randnum = rand.nextInt(min)+1;
	_number2find = randnum;
    }

    ImageIcon makeIcon(String imgLocation) {
      ClassLoader classLoader = getClass().getClassLoader();
      URL imageURL = classLoader.getResource(imgLocation);
      ImageIcon imIcon=null;
      if (imageURL != null) {
	imIcon = new ImageIcon(imageURL);
      }
      else {
	System.err.println("TabbedPane2::makeIcon() Resource icon not found: " + imgLocation);
      }
      return imIcon;
    }

    int getNumber2find() {return _number2find;}
   

    int _number2find;

    JPanel _panel2;
    JButton _buttonImatge;

    String[] _sons;
    String[] _imatges;
    int _nbImatges;
    String _kindOfImg;

    JButtonInt[] _allNumberButtons;
    int _numberOfAllNumberButtons;

}
